"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var defaultBrowserFontSize = '16px';
var getPixelUnit = function (pixelValue) {
    var pxIndex = pixelValue.indexOf('px');
    var pixelUnit = Number(pixelValue.slice(0, pxIndex));
    return pixelUnit;
};
/** Font utility that converts pixels to rem units */
var convertPixelsToRem = function (pixelValue, baseFontSize) {
    if (baseFontSize === void 0) { baseFontSize = defaultBrowserFontSize; }
    var pixelUnit = getPixelUnit(pixelValue);
    var baseFontUnit = getPixelUnit(baseFontSize);
    var calculatedRemUnit = pixelUnit / baseFontUnit;
    /* console.log('typeof calculatedRemUnit=', typeof calculatedRemUnit);
    console.log('calculatedRemUnit=', calculatedRemUnit);
    console.log('\n==='); */
    // if (typeof calculatedRemUnit !== 'number') {
    /* if (calculatedRemUnit != 'undefined') {
        return String(calculatedRemUnit) + 'rem';
    } else {
        // throw new Error('Invalid pixel unit.');
        return false;
    } */
    // https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Error
    return String(calculatedRemUnit) + 'rem';
};
exports.convertPixelsToRem = convertPixelsToRem;
/** Font utility that converts pixels to em units */
var convertPixelsToEm = function (pixelValue, baseFontSize) {
    if (baseFontSize === void 0) { baseFontSize = defaultBrowserFontSize; }
    var pixelUnit = getPixelUnit(pixelValue);
    var baseFontUnit = getPixelUnit(baseFontSize);
    var calculatedEmUnit = pixelUnit / baseFontUnit;
    return String(calculatedEmUnit) + 'em';
};
exports.convertPixelsToEm = convertPixelsToEm;
