"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var useState = React.useState;
var userAgent = navigator.userAgent;
//   https://developers.whatismybrowser.com/useragents/explore/operating_system_name/ios/
// const userAgent = 'Mozilla/4.0 (compatible; MSIE 9.0; Windows NT 6.1)';
// const userAgent = 'Mozilla/5.0 (compatible, MSIE 11, Windows NT 6.3; Trident/7.0; rv:11.0) like Gecko'
// const userAgent = 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1'
var checkIfDeviceIsMobile = function () {
    var match = userAgent.match(/Android/i) ||
        userAgent.match(/BlackBerry/i) ||
        userAgent.match(/iPhone|iPad|iPod/i) ||
        userAgent.match(/Opera Mini/i) ||
        userAgent.match(/IEMobile/i);
    return Boolean(match);
};
var checkIfDeviceIsIos = function () {
    var match = userAgent.match(/iPhone|iPad|iPod/i);
    return Boolean(match);
};
var checkIfDeviceIsIPhone = function () {
    var match = userAgent.match(/Chrome/i);
    return Boolean(match);
};
var checkIfDeviceIsIPad = function () {
    var match = userAgent.match(/Chrome/i);
    return Boolean(match);
};
var checkIfDeviceIsIPod = function () {
    var match = userAgent.match(/Chrome/i);
    return Boolean(match);
};
var checkIfDeviceIsAndroid = function () {
    var match = userAgent.match(/Android/i);
    return Boolean(match);
};
var checkIfDeviceIsBlackberry = function () {
    var match = userAgent.match(/BlackBerry/i);
    return Boolean(match);
};
var checkIfDeviceIsIEMobile = function () {
    var match = userAgent.match(/IEMobile/i);
    return Boolean(match);
};
var checkIfDeviceIsOperaMini = function () {
    var match = userAgent.match(/Opera Mini/i);
    return Boolean(match);
};
var checkIfDeviceIsOpera = function () {
    var match = userAgent.match(/Opr|Opera/i);
    return Boolean(match);
};
var checkIfDeviceIsChrome = function () {
    var match = userAgent.match(/Chrome/i);
    return Boolean(match);
};
var checkIfDeviceIsChromium = function () {
    var match = userAgent.match(/chromium/i);
    return Boolean(match);
};
var checkIfDeviceIsFirefox = function () {
    var match = userAgent.match(/firefox/i);
    return Boolean(match);
};
var checkIfDeviceIsEdge = function () {
    var match = userAgent.match(/edge/i);
    return Boolean(match);
};
var checkIfDeviceIsIE = function () {
    var match = userAgent.match(/msie|trident/i);
    return Boolean(match);
};
// TODO Refactor code - @kareemkibue
var getBrowser = function () {
    var tem;
    var M = userAgent.match(/(opera|chrome|safari|firefox|msie|trident(?=\/))\/?\s*(\d+)/i) || [];
    if (/trident/i.test(M[1])) {
        tem = /\brv[ :]+(\d+)/g.exec(userAgent) || [];
        return {
            name: 'IE',
            version: tem[1],
        };
    }
    if (/msie/i.test(M[1])) {
        return {
            name: 'IE',
            version: M[2],
        };
    }
    // if (M[1] === 'Chrome') {
    // tem = userAgent.match(/\bOPR|Edge\/(\d+)/);
    // if (tem != null)
    // tem[1];
    // }
    // TODO Calculate app userAgent
    // M = M[2] ? [M[1], M[2]] : [navigator.appName, navigator.appVersion, '-?'];
    // if ((tem = userAgent.match(/version\/(\d+)/i)) != null) {
    //     M.splice(1, 1, tem[1]);
    // }
    // return M[1];
    if (!M) {
        return null;
    }
    return {
        name: M[1],
        version: M[2],
    };
};
var useDevice = function () {
    var browser = useState(getBrowser())[0];
    var isAndroid = useState(checkIfDeviceIsAndroid())[0];
    var isBlackberry = useState(checkIfDeviceIsBlackberry())[0];
    var isChrome = useState(checkIfDeviceIsChrome())[0];
    var isChromium = useState(checkIfDeviceIsChromium())[0];
    var isDesktop = useState(!checkIfDeviceIsMobile())[0];
    var isEdge = useState(checkIfDeviceIsEdge())[0];
    var isFirefox = useState(checkIfDeviceIsFirefox())[0];
    var isIE = useState(checkIfDeviceIsIE())[0];
    var isIEMobile = useState(checkIfDeviceIsIEMobile())[0];
    var isIPad = useState(checkIfDeviceIsIPad())[0];
    var isIPhone = useState(checkIfDeviceIsIPhone())[0];
    var isIPod = useState(checkIfDeviceIsIPod())[0];
    var isIos = useState(checkIfDeviceIsIos())[0];
    var isMobile = useState(checkIfDeviceIsMobile())[0];
    var isOpera = useState(checkIfDeviceIsOpera())[0];
    var isOperaMini = useState(checkIfDeviceIsOperaMini())[0];
    return {
        isMobile: isMobile,
        isIos: isIos,
        isAndroid: isAndroid,
        isDesktop: isDesktop,
        isIEMobile: isIEMobile,
        isBlackberry: isBlackberry,
        isOperaMini: isOperaMini,
        isIE: isIE,
        isIPod: isIPod,
        isIPad: isIPad,
        isFirefox: isFirefox,
        isOpera: isOpera,
        isChrome: isChrome,
        isChromium: isChromium,
        isEdge: isEdge,
        isIPhone: isIPhone,
        browser: browser,
    };
};
exports.useDevice = useDevice;
